Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt.image
Class ComponentSampleModel

    java.lang.Object
      |
      +--java.awt.image.SampleModel
            |
            +--java.awt.image.ComponentSampleModel

Direct Known Subclasses:
  BandedSampleModel, PixelInterleavedSampleModel

public class ComponentSampleModel
extends SampleModel

This class represents image data which is stored such that each sample of a pixel occupies one data element of the DataBuffer. It stores the N samples which make up a pixel in N separate data array elements. Different bands may be in different banks of the DataBuffer. Accessor methods are provided so that image data can be manipulated directly. This class can support different kinds of interleaving, e.g. band interleaving, scanline interleaving, and pixel interleaving. Pixel stride is the number of data array elements between two samples for the same band on the same scanline. Scanline stride is the number of data array elements between a given sample and the corresponding sample in the same column of the next scanline. Band offsets denote the number of data array elements from the first data array element of the bank of the DataBuffer holding each band to the first sample of the band. The bands are numbered from 0 to N-1. This class can represent image data for which each sample is an integral number which can be stored in 8, 16, or 32 bits (all samples of a given ComponentSampleModel are stored with the same precision). All strides and offsets must be non-negative. This class supports `TYPE_BYTE`, `TYPE_USHORT`, `TYPE_SHORT`, `TYPE_INT`,

See Also:
  `PixelInterleavedSampleModel`, `BandedSampleModel`

Field Summary
`protected int[]` | `bandOffsets` Offsets for all bands in data array elements.
`protected int[]` | `bankIndices` Index for each bank storing a band of image data.
`protected int` | `numBands` The number of bands in this `ComponentSampleModel`.
`protected int` | `numBanks` The number of banks in this `ComponentSampleModel`.
`protected int` | `pixelStride` Pixel stride (in data array elements) of the region of image data described by this ComponentSampleModel.
`protected int` | `scanlineStride` Line stride (in data array elements) of the region of image data described by this ComponentSampleModel.

Fields inherited from class java.awt.image.SampleModel
`dataType, height, width`

Constructor Summary
`ComponentSampleModel(int dataType, int w, int h, int pixelStride, int scanlineStride, int[] bandOffsets)` Constructs a ComponentSampleModel with the specified parameters.
`ComponentSampleModel(int dataType, int w, int h, int pixelStride, int scanlineStride, int[] bankIndices, int[] bandOffsets)` Constructs a ComponentSampleModel with the specified parameters.

Method Summary
`SampleModel` | `createCompatibleSampleModel(int w, int h)` Creates a new ComponentSampleModel with the specified width and height.
`DataBuffer` | `createDataBuffer()` Creates a DataBuffer that corresponds to this ComponentSampleModel.
`SampleModel` | `createSubsetSampleModel(int[] bands)` This creates a new ComponentSampleModel with a subset of the bands of this ComponentSampleModel.
`int[]` | `getBandOffsets()` Returns the band offset for all bands.
`int[]` | `getBankIndices()` Returns the bank indices for all bands.
`Object` | `getDataElements(int x, int y, Object obj, DataBuffer data)` Returns data for a single pixel in a primitive array of type TransferType.
`int` | `getNumDataElements()` Returns the number of data elements needed to transfer a pixel via the getDataElements and setDataElements methods.
`int` | `getOffset(int x, int y)` Gets the offset for the first band of pixel (x,y).
`int` | `getOffset(int x, int y, int b)` Gets the offset for band b of pixel (x,y).
`int[]` | `getPixel(int x, int y, int[] iArray, DataBuffer data)` Returns all samples for the specified pixel in an int array, one sample per array element.
`int[]` | `getPixels(int x, int y, int w, int h, int[] iArray, DataBuffer data)` Returns all samples for the specified rectangle of pixels in an int array, one sample per array element.
`int` | `getPixelStride()` Returns the pixel stride of this ComponentSampleModel.
`int` | `getSample(int x, int y, int b, DataBuffer data)` Returns as int the sample in a specified band for the pixel located at (x,y).
`double` | `getSampleDouble(int x, int y, int b, DataBuffer data)` Returns the sample in a specified band for a pixel located at (x,y) as a double.
`float` | `getSampleFloat(int x, int y, int b, DataBuffer data)` Returns the sample in a specified band for the pixel located at (x,y) as a float.
`int[]` | `getSamples(int x, int y, int w, int h, int b, int[] iArray, DataBuffer data)` Returns the samples in a specified band for the specified rectangle of pixels in an int array, one sample per data array element.
`int[]` | `getSampleSize()` Returns the number of bits per sample for all bands.
`int` | `getSampleSize(int band)` Returns the number of bits per sample for the specified band.
`int` | `getScanlineStride()` Returns the scanline stride of this ComponentSampleModel.
`void` | `setDataElements(int x, int y, Object obj, DataBuffer data)` Sets the data for a single pixel in the specified DataBuffer from a primitive array of type TransferType.
`void` | `setPixel(int x, int y, int[] iArray, DataBuffer data)` Sets a pixel in the DataBuffer using an int array of samples for input.
`void` | `setPixels(int x, int y, int w, int h, int[] iArray, DataBuffer data)` Sets all samples for a rectangle of pixels from an int array containing one sample per array element.
`void` | `setSample(int x, int y, int b, double s, DataBuffer data)` Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using a double for input.
`void` | `setSample(int x, int y, int b, float s, DataBuffer data)` Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using a float for input.
`void` | `setSample(int x, int y, int b, int s, DataBuffer data)` Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using an int for input.
`void` | `setSamples(int x, int y, int w, int h, int b, int[] iArray, DataBuffer data)` Sets the samples in the specified band for the specified rectangle of pixels from an int array containing one sample per data array element.

Methods inherited from class java.awt.image.SampleModel
`getDataElements, getDataType, getHeight, getNumBands, getPixel, getPixel, getPixels, getPixels, getSamples, getSamples, getTransferType, getWidth, setDataElements, setPixel, setPixel, setPixels, setPixels, setSamples, setSamples`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### bandOffsets

    protected int[] bandOffsets

  Offsets for all bands in data array elements.

### bankIndices

    protected int[] bankIndices

  Index for each bank storing a band of image data.

### numBands

    protected int numBands

  The number of bands in this `ComponentSampleModel`.

### numBanks

    protected int numBanks

  The number of banks in this `ComponentSampleModel`.

### scanlineStride

    protected int scanlineStride

  Line stride (in data array elements) of the region of image data described by this ComponentSampleModel.

### pixelStride

    protected int pixelStride

  Pixel stride (in data array elements) of the region of image data described by this ComponentSampleModel.

Constructor Detail

### ComponentSampleModel

    public ComponentSampleModel(int dataType,
                                int w,
                                int h,
                                int pixelStride,
                                int scanlineStride,
                                int[] bandOffsets)

  Constructs a ComponentSampleModel with the specified parameters. The number of bands will be given by the length of the bandOffsets array. All bands will be stored in the first bank of the DataBuffer.
  Parameters:
    `dataType` - The data type for storing samples.
    `w` - The width (in pixels) of the region of image data described.
    `h` - The height (in pixels) of the region of image data described.
    `pixelStride` - The pixel stride of the region of image data described.
    `scanlineStride` - The line stride of the region of image data described.
    `bandOffsets` - The offsets of all bands.
  Throws:
    `IllegalArgumentException` - if `w` or `h` is not greater than 0
    `IllegalArgumentException` - if `pixelStride` is less than 0
    `IllegalArgumentException` - if `scanlineStride` is less than 0
    `IllegalArgumentException` - if `numBands` is less than 1
    `IllegalArgumentException` - if the product of `w` and `h` is greater than `Integer.MAX_VALUE`
    `IllegalArgumentException` - if `dataType` is not one of the supported data types

### ComponentSampleModel

    public ComponentSampleModel(int dataType,
                                int w,
                                int h,
                                int pixelStride,
                                int scanlineStride,
                                int[] bankIndices,
                                int[] bandOffsets)

  Constructs a ComponentSampleModel with the specified parameters. The number of bands will be given by the length of the bandOffsets array. Different bands may be stored in different banks of the DataBuffer.
  Parameters:
    `dataType` - The data type for storing samples.
    `w` - The width (in pixels) of the region of image data described.
    `h` - The height (in pixels) of the region of image data described.
    `pixelStride` - The pixel stride of the region of image data described.
    `scanlineStride` - The line stride of the region of image data described.
    `bandIndices` - The bank indices of all bands.
    `bandOffsets` - The band offsets of all bands.
  Throws:
    `IllegalArgumentException` - if `w` or `h` is not greater than 0
    `IllegalArgumentException` - if `pixelStride` is less than 0
    `IllegalArgumentException` - if `scanlineStride` is less than 0
    `IllegalArgumentException` - if the length of `bankIndices` does not equal the length of `bankOffsets`
    `IllegalArgumentException` - if any of the bank indices of `bandIndices` is less than 0

Method Detail

### createCompatibleSampleModel

    public SampleModel createCompatibleSampleModel(int w,
                                                   int h)

  Creates a new ComponentSampleModel with the specified width and height. The new SampleModel will have the same number of bands, storage data type, interleaving scheme, and pixel stride as this SampleModel.
  Overrides:
    `createCompatibleSampleModel` in class `SampleModel`
  Parameters:
    `w` - the width of the resulting `SampleModel`
    `h` - the height of the resulting `SampleModel`
  Throws:
    `IllegalArgumentException` - if `w` or `h` is not greater than 0

### createSubsetSampleModel

    public SampleModel createSubsetSampleModel(int[] bands)

  This creates a new ComponentSampleModel with a subset of the bands of this ComponentSampleModel. The new ComponentSampleModel can be used with any DataBuffer that the existing ComponentSampleModel can be used with. The new ComponentSampleModel/DataBuffer combination will represent an image with a subset of the bands of the original ComponentSampleModel/DataBuffer combination.
  Overrides:
    `createSubsetSampleModel` in class `SampleModel`

### createDataBuffer

    public DataBuffer createDataBuffer()

  Creates a DataBuffer that corresponds to this ComponentSampleModel. The DataBuffer's data type, number of banks, and size will be consistent with this ComponentSampleModel.
  Overrides:
    `createDataBuffer` in class `SampleModel`

### getOffset

    public int getOffset(int x,
                         int y)

  Gets the offset for the first band of pixel (x,y). A sample of the first band can be retrieved from a DataBuffer `data` with a ComponentSampleModel `csm` as

              data.getElem(csm.getOffset(x, y));

### getOffset

    public int getOffset(int x,
                         int y,
                         int b)

  Gets the offset for band b of pixel (x,y). A sample of band `b` can be retrieved from a DataBuffer `data` with a ComponentSampleModel `csm` as

             data.getElem(csm.getOffset(x, y, b));

### getSampleSize

    public final int[] getSampleSize()

  Returns the number of bits per sample for all bands.
  Overrides:
    `getSampleSize` in class `SampleModel`

### getSampleSize

    public final int getSampleSize(int band)

  Returns the number of bits per sample for the specified band.
  Overrides:
    `getSampleSize` in class `SampleModel`

### getBankIndices

    public final int[] getBankIndices()

  Returns the bank indices for all bands.

### getBandOffsets

    public final int[] getBandOffsets()

  Returns the band offset for all bands.

### getScanlineStride

    public final int getScanlineStride()

  Returns the scanline stride of this ComponentSampleModel.

### getPixelStride

    public final int getPixelStride()

  Returns the pixel stride of this ComponentSampleModel.

### getNumDataElements

    public final int getNumDataElements()

  Returns the number of data elements needed to transfer a pixel via the getDataElements and setDataElements methods. For a ComponentSampleModel this is identical to the number of bands.
  Overrides:
    `getNumDataElements` in class `SampleModel`
  See Also:
    `SampleModel.getNumDataElements()`

### getDataElements

    public Object getDataElements(int x,
                                  int y,
                                  Object obj,
                                  DataBuffer data)

  Returns data for a single pixel in a primitive array of type TransferType. For a ComponentSampleModel, this will be the same as the data type, and samples will be returned one per array element. Generally, obj should be passed in as null, so that the Object will be created automatically and will be of the right primitive data type.

  The following code illustrates transferring data for one pixel from DataBuffer `db1`, whose storage layout is described by ComponentSampleModel `csm1`, to DataBuffer `db2`, whose storage layout is described by ComponentSampleModel `csm2`. The transfer will generally be more efficient than using getPixel/setPixel.

       	     ComponentSampleModel csm1, csm2;
      	     DataBufferInt db1, db2;
       	     csm2.setDataElements(x, y,
                                  csm1.getDataElements(x, y, null, db1), db2);

  Using getDataElements/setDataElements to transfer between two DataBuffer/SampleModel pairs is legitimate if the SampleModels have the same number of bands, corresponding bands have the same number of bits per sample, and the TransferTypes are the same.

  If obj is non-null, it should be a primitive array of type TransferType. Otherwise, a ClassCastException is thrown. An ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds, or if obj is non-null and is not large enough to hold the pixel data.

  Overrides:
    `getDataElements` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `obj` - If non-null, a primitive array in which to return the pixel data.
    `data` - The DataBuffer containing the image data.

### getPixel

    public int[] getPixel(int x,
                          int y,
                          int[] iArray,
                          DataBuffer data)

  Returns all samples for the specified pixel in an int array, one sample per array element. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `getPixel` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `iArray` - If non-null, returns the samples in this array.
    `data` - The DataBuffer containing the image data.

### getPixels

    public int[] getPixels(int x,
                           int y,
                           int w,
                           int h,
                           int[] iArray,
                           DataBuffer data)

  Returns all samples for the specified rectangle of pixels in an int array, one sample per array element. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `getPixels` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the upper left pixel location.
    `y` - The Y coordinate of the upper left pixel location.
    `w` - The width of the pixel rectangle.
    `h` - The height of the pixel rectangle.
    `iArray` - If non-null, returns the samples in this array.
    `data` - The DataBuffer containing the image data.

### getSample

    public int getSample(int x,
                         int y,
                         int b,
                         DataBuffer data)

  Returns as int the sample in a specified band for the pixel located at (x,y). ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `getSample` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `b` - The band to return.
    `data` - The DataBuffer containing the image data.

### getSampleFloat

    public float getSampleFloat(int x,
                                int y,
                                int b,
                                DataBuffer data)

  Returns the sample in a specified band for the pixel located at (x,y) as a float. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `getSampleFloat` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `b` - The band to return.
    `data` - The DataBuffer containing the image data.

### getSampleDouble

    public double getSampleDouble(int x,
                                  int y,
                                  int b,
                                  DataBuffer data)

  Returns the sample in a specified band for a pixel located at (x,y) as a double. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `getSampleDouble` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `b` - The band to return.
    `data` - The DataBuffer containing the image data.

### getSamples

    public int[] getSamples(int x,
                            int y,
                            int w,
                            int h,
                            int b,
                            int[] iArray,
                            DataBuffer data)

  Returns the samples in a specified band for the specified rectangle of pixels in an int array, one sample per data array element. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `getSamples` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the upper left pixel location.
    `y` - The Y coordinate of the upper left pixel location.
    `w` - The width of the pixel rectangle.
    `h` - The height of the pixel rectangle.
    `b` - The band to return.
    `iArray` - If non-null, returns the samples in this array.
    `data` - The DataBuffer containing the image data.

### setDataElements

    public void setDataElements(int x,
                                int y,
                                Object obj,
                                DataBuffer data)

  Sets the data for a single pixel in the specified DataBuffer from a primitive array of type TransferType. For a ComponentSampleModel, this will be the same as the data type, and samples are transferred one per array element.

  The following code illustrates transferring data for one pixel from DataBuffer `db1`, whose storage layout is described by ComponentSampleModel `csm1`, to DataBuffer `db2`, whose storage layout is described by ComponentSampleModel `csm2`. The transfer will generally be more efficient than using getPixel/setPixel.

       	     ComponentSampleModel csm1, csm2;
      	     DataBufferInt db1, db2;
       	     csm2.setDataElements(x, y, csm1.getDataElements(x, y, null, db1),
                                  db2);

  Using getDataElements/setDataElements to transfer between two DataBuffer/SampleModel pairs is legitimate if the SampleModels have the same number of bands, corresponding bands have the same number of bits per sample, and the TransferTypes are the same.

  obj must be a primitive array of type TransferType. Otherwise, a ClassCastException is thrown. An ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds, or if obj is not large enough to hold the pixel data.

  Overrides:
    `setDataElements` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `obj` - A primitive array containing pixel data.
    `data` - The DataBuffer containing the image data.

### setPixel

    public void setPixel(int x,
                         int y,
                         int[] iArray,
                         DataBuffer data)

  Sets a pixel in the DataBuffer using an int array of samples for input. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `setPixel` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `iArray` - The input samples in an int array.
    `data` - The DataBuffer containing the image data.

### setPixels

    public void setPixels(int x,
                          int y,
                          int w,
                          int h,
                          int[] iArray,
                          DataBuffer data)

  Sets all samples for a rectangle of pixels from an int array containing one sample per array element. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `setPixels` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the upper left pixel location.
    `y` - The Y coordinate of the upper left pixel location.
    `w` - The width of the pixel rectangle.
    `h` - The height of the pixel rectangle.
    `iArray` - The input samples in an int array.
    `data` - The DataBuffer containing the image data.

### setSample

    public void setSample(int x,
                          int y,
                          int b,
                          int s,
                          DataBuffer data)

  Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using an int for input. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `setSample` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `b` - The band to set.
    `s` - The input sample as an int.
    `data` - The DataBuffer containing the image data.

### setSample

    public void setSample(int x,
                          int y,
                          int b,
                          float s,
                          DataBuffer data)

  Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using a float for input. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `setSample` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `b` - The band to set.
    `s` - The input sample as a float.
    `data` - The DataBuffer containing the image data.

### setSample

    public void setSample(int x,
                          int y,
                          int b,
                          double s,
                          DataBuffer data)

  Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using a double for input. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `setSample` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the pixel location.
    `y` - The Y coordinate of the pixel location.
    `b` - The band to set.
    `s` - The input sample as a double.
    `data` - The DataBuffer containing the image data.

### setSamples

    public void setSamples(int x,
                           int y,
                           int w,
                           int h,
                           int b,
                           int[] iArray,
                           DataBuffer data)

  Sets the samples in the specified band for the specified rectangle of pixels from an int array containing one sample per data array element. ArrayIndexOutOfBoundsException may be thrown if the coordinates are not in bounds.
  Overrides:
    `setSamples` in class `SampleModel`
  Parameters:
    `x` - The X coordinate of the upper left pixel location.
    `y` - The Y coordinate of the upper left pixel location.
    `w` - The width of the pixel rectangle.
    `h` - The height of the pixel rectangle.
    `b` - The band to set.
    `iArray` - The input samples in an int array.
    `data` - The DataBuffer containing the image data.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.